# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%define section free

Name:           freemarker
Version:        2.3.16
Release:        2%{?dist}
Epoch:          0
Summary:        FreeMarker template engine
License:        BSD-style
Group:          Development/Libraries/Java
URL:            http://freemarker.sourceforge.net/
Source0:        http://download.sourceforge.net/freemarker/freemarker-2.3.16.tar.gz
Patch0:         freemarker-2.3.15-JythonHashModel.patch
Patch1:         freemarker-2.3.15-BeansWrapper.patch
Patch2:         freemarker-2.3.15-NodeListModel.patch
Patch3:         freemarker-2.3.15-JdomNavigator.patch
Patch4:         freemarker-build.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       java >= 0:1.5.0
Requires:       avalon-logkit
Requires:       servlet_api
Requires:       jaxen >= 0:1.1
Requires:       jpackage-utils
Requires:       jython
Requires:       jdom
Requires:       dom4j
Requires:       el_1_0_api
Requires:       jpackage-utils
Requires:       log4j
Requires:       rhino
Requires:       saxpath
Requires:       struts
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  ant-junit
BuildRequires:  ant-nodeps
BuildRequires:  emma
BuildRequires:  junit
BuildRequires:  javacc
BuildRequires:  jaxen >= 0:1.1
BuildRequires:  jython
BuildRequires:  avalon-logkit
BuildRequires:  dom4j
BuildRequires:  el_1_0_api
BuildRequires:  jdom
BuildRequires:  jsp_1_2_api
BuildRequires:  jsp_2_0_api
BuildRequires:  jsp_2_1_api
BuildRequires:  log4j
BuildRequires:  rhino
BuildRequires:  saxpath
BuildRequires:  servlet_2_5_api
BuildRequires:  struts
BuildRequires:  xerces-j2
BuildRequires:  xalan-j2
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
FreeMarker is a "template engine"; a generic tool to 
generate text output (anything from HTML or RTF to 
autogenerated source code) based on templates.
FreeMarker is designed to be practical for the generation 
of HTML Web pages, particularly by servlet-based applications 
following the MVC (Model View Controller) pattern. 
Although FreeMarker has some programming capabilities, 
it is not a full-blown programming language like PHP. Instead, 
Java programs prepare the data to be displayed, and FreeMarker 
just generates textual pages that display the prepared data 
using templates. 
FreeMarker is not a Web application framework. It is suitable 
for a component in a Web application framework, but the 
FreeMarker engine itself knows nothing about HTTP or servlets. 


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -n %{name}-%{version}
chmod -R go=u-w *
find -type f -name \*.jar | xargs -t rm

for i in `find -type f -name \*.java | xargs grep -l 'Generated By:JavaCC'`; do
    rm $i
done
#<available file="lib/README.txt"/>
touch lib/README.txt
#<available file="lib/ant.jar"/>
ln -s $(build-classpath ant) lib
#<available file="lib/dom4j.jar"/>
ln -s $(build-classpath dom4j) lib
#<available file="lib/emma.jar"/>
ln -s $(build-classpath emma) lib
#<available file="lib/emma_ant.jar"/>
ln -s $(build-classpath emma_ant) lib
#<available file="lib/javacc.jar"/>
ln -s $(build-classpath javacc) lib/javacc.jar
#ln -s $(build-classpath freemarker) lib/freemarker-bootstrap.jar
ln -s $(build-classpath ant) lib/freemarker-bootstrap.jar
#<available file="lib/javarebel-sdk.jar"/>
ln -s $(build-classpath ant) lib/javarebel-sdk.jar
#<available file="lib/jaxen.jar"/>
ln -s $(build-classpath jaxen) lib
#<available file="lib/jdom.jar"/>
ln -s $(build-classpath jdom) lib
#<available file="lib/js.jar"/>
ln -s $(build-classpath js) lib
#<available file="lib/junit.jar"/>
ln -s $(build-classpath junit) lib
#<available file="lib/jython.jar"/>
ln -s $(build-classpath jython) lib
#<available file="lib/log4j.jar"/>
ln -s $(build-classpath log4j) lib
#<available file="lib/logkit.jar"/>
ln -s $(build-classpath avalon-logkit) lib/logkit.jar
#<available file="lib/rt122.jar"/>
#ln -s $JAVA_HOME/jre/lib/rt.jar lib/rt122.jar
#<available file="lib/saxpath.jar"/>
ln -s $(build-classpath saxpath) lib
#<available file="lib/servlet.jar"/>
ln -s $(build-classpath servlet_2_5_api) lib/servlet.jar
#<available file="lib/struts.jar"/>
ln -s $(build-classpath struts) lib
#<available file="lib/jsp-api-1.2.jar"/>
ln -s $(build-classpath jsp_1_2_api) lib/jsp-api-1.2.jar
#<available file="lib/jsp-api-2.0.jar"/>
ln -s $(build-classpath jsp_2_0_api) lib/jsp-api-2.0.jar
#<available file="lib/jsp-api-2.1.jar"/>
ln -s $(build-classpath jsp_2_1_api) lib/jsp-api-2.1.jar
#<available file="lib/xalan.jar"/>
ln -s $(build-classpath xalan-j2) lib/xalan.jar

%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p0 -b .sav2
%patch3 -p0 -b .sav3
%patch4 -p0 -b .sav4
rm src/freemarker/ext/beans/JavaRebelIntegration.java

%build
export JAVA_HOME=%{java_home}
ln -s $JAVA_HOME/jre/lib/rt.jar lib/rt122.jar
export OPT_JAR_LIST="ant/ant-junit junit ant/ant-nodeps javacc3"
export CLASSPATH=$(build-classpath \
el_1_0_api \
)
%{ant}
%{ant} create-pom

%install
rm -rf %{buildroot}

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}

install -p -m 644 lib/freemarker.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -s ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -p -m 644 build/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.freemarker freemarker %{version} JPP %{name}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr docs/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
rm -r $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/docs/api

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc LICENSE.txt
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %dir %{_docdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}/*

%changelog
* Mon Mar 07 2011 David Walluck <dwalluck@redhat.com> 0:2.3.16-2
- bootstrap not required

* Mon Mar 07 2011 David Walluck <dwalluck@redhat.com> 0:2.3.16-1
- 2.3.16

* Mon Mar 23 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.3.15-1.jpp5
- 2.3.15

* Mon Apr 24 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.3.6-2jpp
- Use compat javacc3 package

* Thu Mar 30 2006 Ralph Apel <r.apel at r-apel.de> 0:2.3.6-1jpp
- Upgrade to 2.3.6
- Replace old avalon-framework, avalon-logkit with current excalibur-*

* Fri Mar 10 2006 Fernando Nasser <fnasser@redhat.com> 0:2.3-2jpp
- First JPP 1.7 build

* Fri Oct 08 2004 Ralph Apel <r.apel at r-apel.de> 0:2.3-1jpp
- First release

